From 2b4f07d8d84f7460e0042a1618ed5f212965f61b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 02 2021 08:06:59 +0000
Subject: [PATCH 1952/2232] Explicit instantiations for easy typecheck coverage in test suite


---

diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 50a11da..827acc6 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -819,3 +819,23 @@ std::unique_ptr<I> ns_c_return_unique_ptr_ns() {
   return std::unique_ptr<I>(new I());
 }
 } // namespace I
+
+// Instantiate any remaining class member functions not already covered above.
+// This is an easy way to at least typecheck anything missed by unit tests.
+// https://en.cppreference.com/w/cpp/language/class_template#Explicit_instantiation
+// > When an explicit instantiation names a class template specialization, it
+// > serves as an explicit instantiation of the same kind (declaration or
+// > definition) of each of its non-inherited non-template members that has not
+// > been previously explicitly specialized in the translation unit.
+template struct rust::Box<tests::Shared>;
+template struct rust::Slice<const char>;
+template struct rust::Slice<const uint8_t>;
+template struct rust::Slice<uint8_t>;
+template struct rust::Slice<const tests::Shared>;
+template struct rust::Slice<tests::Shared>;
+template struct rust::Slice<const tests::R>;
+template struct rust::Slice<tests::R>;
+template struct rust::Vec<uint8_t>;
+template struct rust::Vec<rust::String>;
+template struct rust::Vec<tests::Shared>;
+template struct rust::Fn<size_t(rust::String)>;

